
Ruby - Bug #14023

SyntaxError on array argument and block

10/18/2017 08:10 AM - k0kubun (Takashi Kokubun)

Status: Rejected   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 2.5   

ruby -v: ruby 2.5.0preview1 (2017-10-10 trunk

60153) [x86_64-darwin16]

Backport: 2.3: DONTNEED, 2.4: REQUIRED

Description

$ RBENV_VERSION=2.4.2 ruby -v

ruby 2.4.2p198 (2017-09-14 revision 59899) [x86_64-darwin16]

$ RBENV_VERSION=2.4.2 ruby -c -e 'a [] {}'

Syntax OK

$ RBENV_VERSION=2.5.0-preview1 ruby -v

ruby 2.5.0preview1 (2017-10-10 trunk 60153) [x86_64-darwin16]

$ RBENV_VERSION=2.5.0-preview1 ruby -c -e 'a [] {}'

-e:1: syntax error, unexpected '{', expecting end-of-input

a [] {}

     ^

 Is this intentional? This causes syntax error on 

https://github.com/plataformatec/devise/blob/v4.2.0/app/controllers/devise/sessions_controller.rb#L5.

Related issues:

Related to Ruby - Bug #13547: [].delete 1 { 'NG' } Closed

Related to Ruby - Bug #13691: Word- and symbol array literals not valid where... Rejected

Is duplicate of Ruby - Bug #505: 1.upto 2 {|i| p i } Closed 08/27/2008

Has duplicate Ruby - Bug #14433: Error with Trailblazer Wrap using ruby 2.5.0 Third Party's Issue

History

#1 - 10/18/2017 09:05 AM - wanabe (_ wanabe)

- Related to Bug #13547: [].delete 1 { 'NG' } added

#2 - 10/18/2017 09:06 AM - wanabe (_ wanabe)

- Related to Bug #13691: Word- and symbol array literals not valid where regular array is added

#3 - 12/15/2017 08:45 AM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

This seems regression caused by Bug #13547

% RBENV_VERSION=2.3.5 ruby -c -e 'a [] {}'

Syntax OK

% RBENV_VERSION=2.3.5 ruby -c -e '1.upto 2 {|i|p i}'

-e:1: syntax error, unexpected '{', expecting end-of-input

1.upto 2 {|i|p i}

          ^

%  RBENV_VERSION=2.4.1 ruby -c -e 'a [] {}'

Syntax OK

%  RBENV_VERSION=2.4.1 ruby -c -e '1.upto 2 {|i|p i}'

Syntax OK

% ~/local/ruby/bin/ruby -c -e 'a [] {}'
https://github.com/plataformatec/devise/blob/v4.2.0/app/controllers/devise/sessions_controller.rb#L5
https://redmine.ruby-lang.org/issues/13547


-e:1: syntax error, unexpected '{', expecting end-of-input

a [] {}

     ^

% ~/local/ruby/bin/ruby -c -e '1.upto 2 {|i|p i}'

-e:1: syntax error, unexpected '{', expecting end-of-input

1.upto 2 {|i|p i}

         ^

#4 - 12/15/2017 08:45 AM - naruse (Yui NARUSE)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN to 2.3: DONTNEED, 2.4: REQUIRED

#5 - 12/19/2017 06:55 AM - shyouhei (Shyouhei Urabe)

- Is duplicate of Bug #505: 1.upto 2 {|i| p i } added

#6 - 12/19/2017 06:57 AM - shyouhei (Shyouhei Urabe)

https://bugs.ruby-lang.org/projects/ruby-trunk/repository/revisions/19197

Matz's intention is very clear that this kind of expression shall render syntax errors.

#7 - 12/23/2017 11:04 AM - naruse (Yui NARUSE)

- Status changed from Assigned to Rejected

#8 - 02/02/2018 10:38 AM - k0kubun (Takashi Kokubun)

- Has duplicate Bug #14433: Error with Trailblazer Wrap using ruby 2.5.0 added
